Option Explicit
Const SW = "2.00"		'SW-Version from 19.09.2019
Const NumOfLines = 24		'Number of lines per language in translation file with +++ and --- lines

Dim TextArray
ReDim TextArray(NumOfLines-2)		'max. number of text lines per language
Dim i, j
Dim fso, LngStr, LngNr, LngSum, AllLng, StartLng, EndPos, TransFile, Zeile, UpdateFolder, SubFolder, strDrive
Const OverWriteFiles = True
Const DateiPfad = "Translation.txt"

Set fso = CreateObject("Scripting.FileSystemObject")

If (fso.FileExists(DateiPfad)) Then			'Translation file available? IF YES: Get all languages for the language selection menu
	Set TransFile = fso.OpenTextFile(DateiPfad, 1)
	LngSum = 0
	AllLng =""
	Zeile = ""
	Do While TransFile.AtEndOfStream <> True
		Zeile = TransFile.ReadLine
		EndPos = InStrRev(Zeile, "+++")
		If (EndPos > 0) Then
			LngStr = Mid(Zeile, 4, EndPos-4)
			AllLng = AllLng &vbTab& LngSum & ":" &vbTab& LngStr &vbNewLine
			LngSum = LngSum + 1
		End If
	Loop
	TransFile.Close
Else
	MsgBox "CANCELLED (No translation file available)",  vbCritical + vbOKonly, TextArray(15) & "  " & SW
	WScript.Quit
End If


LngNr = InputBox(AllLng, "Language?")

If ( (CInt(LngNr) < 0) Or (CInt(LngNr) >= LngSum) Or (LngNr = "") ) Then
	MsgBox "CANCELLED by user",  vbCritical + vbOKonly, "CPC Update Routine" & "  " & SW
	WScript.Quit
End If


StartLng = LngNr * NumOfLines + LngNr + 1


If (fso.FileExists(DateiPfad)) Then
	Set TransFile = fso.OpenTextFile(DateiPfad, 1)
	i = 0
	j = 0
	Zeile = ""
	Do While TransFile.AtEndOfStream <> True
		Zeile = TransFile.ReadLine
		If ( (i >= StartLng) And (i < StartLng+NumOfLines-2) ) Then
			TextArray(j) = Zeile
			j = j + 1
		End If
		i=i+1
	Loop
	TransFile.Close
Else
	MsgBox "CANCELLED (No translation file available)",  vbCritical + vbOKonly, TextArray(15) & "  " & SW
	WScript.Quit
End If
	
' Firmware Update
MsgBox TextArray(8) &vbNewLine + vbNewLine&_
     + TextArray(9) &vbNewLine + vbNewLine&_
     + TextArray(10) &vbNewLine + vbNewLine&_
     + TextArray(11), vbOKOnly, TextArray(16) & "  " & SW


strDrive = SelectFolder("", TextArray(12))
If strDrive = vbNull Then
	MsgBox TextArray(14),  vbCritical + vbOKonly, TextArray(16) & "  " & SW
	WScript.Quit
 Else
 	If fso.FileExists(strDrive & "\firmware.bin") Then
 		fso.DeleteFile strDrive & "\firmware.bin"
 	End If
	fso.CopyFile ".\HHT-FW\HHT_FW_V_711.bin", strDrive, OverWriteFiles
	MsgBox TextArray(13), vbInformation + vbOKonly, TextArray(16) & "  " & SW
End If

' SD-Card Update
MsgBox _
     + TextArray(0) &vbNewLine + vbNewLine&_
     + TextArray(1) &vbNewLine + vbNewLine&_
     + TextArray(2) &vbNewLine + vbNewLine&_
     + TextArray(3), vbOKOnly, TextArray(16) & "  " & SW

UpdateFolder = ""
DoFolders fso.GetFolder(".\UPDATE")     'Get versions from \update folder

If Msgbox(UpdateFolder, vbYesNo + vbQuestion, TextArray(18)) = vbYes Then ' MessageBox Abfrage
	strDrive = SelectFolder("",TextArray(4) &vbCRLF+vbCRLF& TextArray(5))
	If ( (strDrive = vbNull) Or (strDrive = "::{") ) Then		'"::{" --> no drive selected
		MsgBox TextArray(14),  vbCritical + vbOKonly, TextArray(16) & "  " & SW
		WScript.Quit
  Else
  	If fso.FolderExists(strDrive & "\CONFIG") Then
  		fso.DeleteFolder strDrive & "\CONFIG"
  	End If
  	WScript.Sleep 1000
		fso.CopyFolder fso.GetFolder(".\CONFIG"), strDrive, OverWriteFiles		'Manchmal Laufzeitfehler: "Erlaubnis verweigert" oder "Ungltiger Proceduraufruf oder ungltiges Argument"

  	If fso.FolderExists(strDrive & "\LANGUAGE") Then
  		fso.DeleteFolder strDrive & "\LANGUAGE"
  	End If
		WScript.Sleep 1000
		fso.CopyFolder fso.GetFolder(".\LANGUAGE"), strDrive, OverWriteFiles

  	If fso.FolderExists(strDrive & "\UPDATE") Then
  		fso.DeleteFolder strDrive & "\UPDATE"
  	End If
		WScript.Sleep 1000
		fso.CopyFolder fso.GetFolder(".\UPDATE"), strDrive, OverWriteFiles
	End If
	UpdateFolder = ""          'Check copied versions
	DoFolders fso.GetFolder(strDrive & "\UPDATE")
	MsgBox UpdateFolder, vbInformation + vbOKOnly, TextArray(17)		'Show current SW
    
    MsgBox TextArray(6), vbInformation + vbOKonly, TextArray(16) & "  " & SW
Else
	MsgBox TextArray(15),  vbCritical + vbOKonly, TextArray(16) & "  " & SW		'User cancelled update
	WScript.Quit
End If


MsgBox TextArray(7),  vbExclamation + vbOKonly, TextArray(16) & "  " & SW


Sub DoFolders(Folder) 
  If LCase(Folder.Name) <> LCase("System Volume Information") Then
		For Each SubFolder In Folder.SubFolders
			Select Case Left(SubFolder.Name, 3)
				Case "CSW"
						UpdateFolder = UpdateFolder & vbCRLF &vbTab& "CSW" &vbTab&vbTab& ":  " & Right(SubFolder.Name, 2)
				Case "DSP"
						UpdateFolder = UpdateFolder & vbCRLF &vbTab& "DSP" &vbTab&vbTab& ":  " & Mid(SubFolder.Name, 5, 2) & "." & Mid(SubFolder.Name, 7, 2)
				Case "ECU"
						UpdateFolder = UpdateFolder & vbCRLF &vbTab& "CCU" &vbTab&vbTab& ":  " & Mid(SubFolder.Name, 5, 2) & "." & Mid(SubFolder.Name, 7, 2)
			End Select
			DoFolders(SubFolder) 
		Next 
	End If 
End Sub


Function SelectFolder( myStartFolder, Headline )
    Dim objFolder, objItem, objShell
    
    On Error Resume Next
    SelectFolder = vbNull

    Set objShell  = CreateObject( "Shell.Application" )
    Set objFolder = objShell.BrowseForFolder( 0, Headline, &H1200, myStartFolder )

    If IsObject( objfolder ) Then 
    	SelectFolder = Left(objFolder.Self.Path, 3)
    End If

    Set objFolder = Nothing
    Set objshell  = Nothing
    On Error Goto 0
End Function
